/*
 * CSE3001.  Compiler project based on "Modern Compiler Implementation
 * in Java" by Andrew W. Appel.
 *
 */

package canon;

import temp.Label;

import tree.Stm;
import tree.StmList;


public class BasicBlocks {

   public StmListList blocks;
   public Label done;

   private StmListList lastBlock;
   private StmList lastStm;

   private void addStm (Stm s) {
      lastStm = lastStm.tail = new StmList(s,null);
   }

   private void doStms(StmList l) {
      if (l==null) {
	 doStms (new StmList(new tree.JUMP(done), null));
      } else if (l.head instanceof tree.JUMP 
	      || l.head instanceof tree.CJUMP) {
	 addStm(l.head);
	 mkBlocks(l.tail);
      } else if (l.head instanceof tree.LABEL) {
	 doStms (new StmList(new tree.JUMP(((tree.LABEL)l.head).label), l));
      } else {
	 addStm(l.head);
	 doStms(l.tail);
      }
  }

   private void mkBlocks (StmList l) {
      if (l==null) return;
      else if (l.head instanceof tree.LABEL) {
	 lastStm = new StmList(l.head,null);
	 if (lastBlock==null)
	    lastBlock= blocks= new StmListList(lastStm,null);
	 else
	    lastBlock = lastBlock.tail = new StmListList(lastStm,null);
	 doStms(l.tail);
      }
     else mkBlocks(new tree.StmList(new tree.LABEL(new Label()), l));
  }
   

   public BasicBlocks (StmList stms) {
      done = new Label();
      mkBlocks(stms);
   }
}
