package frame;

import assem.Proc;

import temp.Label;
import temp.Temp;
import temp.TempMap;

import translate.Access;

import tree.Stm;
import tree.StmList;

import java.util.List;

import regalloc.RegAlloc;

public abstract class Frame implements TempMap
{
    abstract public Temp FP();
    abstract public Temp RV();
    
    abstract public int frameSize();
    abstract public int wordSize();
    abstract public int allocLocal();
    abstract public int allocFormal();
    abstract public String string(String string, Label label);
    abstract public String label(String label);

    abstract public List usableRegs();
    
    abstract public Stm procEntryExit1(Stm stm);
    abstract public List procEntryExit3(List inst);
    abstract public Proc procEntryExit4(Proc proc);

    abstract public List codegen(StmList stms, RegAlloc ra);
}
