package sparc;

import temp.Temp;
import temp.TempList;
import temp.TempMap;
import java.util.HashMap;

public class Registers implements TempMap
{
    private HashMap hm = new HashMap();

    Registers()
    {
        // globals
        add("%g0", new Temp());
        add("%g1", new Temp());
        add("%g3", new Temp());
        add("%g4", new Temp());
        add("%g5", new Temp());
        add("%g6", new Temp());
        add("%g7", new Temp());

        // output
        add("%o0", new Temp());
        add("%o1", new Temp());
        add("%o2", new Temp());
        add("%o3", new Temp());
        add("%o4", new Temp());
        add("%o5", new Temp());
        add("%o6", new Temp());
        add("%o7", new Temp());
        add("%o7", new Temp());
        add("%o7", new Temp());
        add("%o7", new Temp());
        add("%o7", new Temp());
        add("%o7", new Temp());
        add("%o7", new Temp());
        add("%o7", new Temp());
        add("%o7", new Temp());
        add("%o7", new Temp());
        add("%o7", new Temp());
        add("%o7", new Temp());

        // input
        add("%i0", new Temp());
        add("%i1", new Temp());
        add("%i2", new Temp());
        add("%i3", new Temp());
        add("%i4", new Temp());
        add("%i5", new Temp());
        add("%i6", new Temp());
        add("%i7", new Temp());

        // locals
        add("%l0", new Temp());
        add("%l1", new Temp());
        add("%l2", new Temp());
        add("%l3", new Temp());
        add("%l4", new Temp());
        add("%l5", new Temp());
        add("%l6", new Temp());
        add("%l7", new Temp());

        // special
        add("%fp", new Temp());
        add("%sp", new Temp());
    }

    private TempList L(Temp t, TempList l)
    { return new TempList(t,l); }
    
    public RegList localRegs() 
    {
        TempList l = null;
        l = L(regMap("%l7"), l);
        l = L(regMap("%l6"), l);
        l = L(regMap("%l5"), l);                        
        l = L(regMap("%l4"), l);
        l = L(regMap("%l3"), l);
        l = L(regMap("%l2"), l);                        
        l = L(regMap("%l1"), l);
        l = L(regMap("%l0"), l);
        /*
          l = L(regMap("%i0"), l);
          l = L(regMap("%i1"), l);
          l = L(regMap("%i2"), l);                        
          l = L(regMap("%i3"), l);
          l = L(regMap("%i4"), l);
          l = L(regMap("%i5"), l);                        
          l = L(regMap("%i6"), l);
          l = L(regMap("%i7"), l);
        */
        return new RegList(l);
    }

    public RegList outRegs() 
    {
        TempList l = null;
        l = L(regMap("%o7"), l);
        l = L(regMap("%o6"), l);
        l = L(regMap("%o5"), l);                        
        l = L(regMap("%o4"), l);
        l = L(regMap("%o3"), l);
        l = L(regMap("%o2"), l);                        
        l = L(regMap("%o1"), l);
        l = L(regMap("%o0"), l);
        return new RegList(l);
    }

    public RegList inRegs() 
    {
        TempList l = null;
        l = L(regMap("%i7"), l);
        l = L(regMap("%i6"), l);
        l = L(regMap("%i5"), l);                 
        l = L(regMap("%i4"), l);
        l = L(regMap("%i3"), l);
        l = L(regMap("%i2"), l);                        
        l = L(regMap("%i1"), l);
        l = L(regMap("%i0"), l);
        return new RegList(l);
    }
    
    private void add(String reg, Temp temp) 
    {
        hm.put(reg, temp);
        hm.put(temp, reg);
    }

    public Temp fp()    { return regMap("%fp"); }
    public Temp sp()    { return regMap("%sp"); }
    public Temp putRV() { return regMap("%i0"); }
    public Temp getRV() { return regMap("%o0"); }

    public Temp   regMap(String reg) { return (Temp)hm.get(reg); }
    public String tempMap(Temp temp) { return (String)hm.get(temp); }
    public void mapTemp(Temp a, Temp b) { hm.put(a, tempMap(b)); }
}
