package symbol;

import java.util.List;
import java.util.Arrays;
import java.util.Collections;
import java.util.LinkedList;

public class Record extends Type {

   public static class Field {
      public final String fieldName;
      public final Type fieldType;
      public Field (String n, Type t) { fieldName=n; fieldType=t; }
      public String toString () { return fieldName+":"+fieldType; }
   }

   public final List fields;        // LinkedList of class Field

   public Record (List f)     { fields = f; }

   public Record (Record.Field[] a)     { fields = Arrays.asList (a); }

   public Record (Field f) {
      this (Collections.singletonList (f));
   }

   public Record (String n, Type t) {
      this (new Field (n, t));
   }

   public Record () {
      this (new LinkedList ());
      /*
      this (Collections.EMPTY_LIST);
      does not support add!
      */
   }

  public String toString() 
  { return "record"; }
}
   
