/*
 * CSE3001.  Compiler project based on "Modern Compiler Implementation
 * in Java" by Andrew W. Appel.
 *
 */

package syntax;

import java.util.LinkedList;

public class FunctionDec extends Dec {
   public final LinkedList params; // List of VarDec
   public final String result;     // optional
   public final Exp body;
   public       FunctionDec next;  // next mutually recursive function declaration
   public FunctionDec (int p, String n, LinkedList a, Exp b) {
      this (p,n,a,null,b,null);
   }
   public FunctionDec (int p, String n, LinkedList a, Exp b, FunctionDec x) {
      this (p,n,a,null,b,x);
   }
   public FunctionDec (int p, String n, LinkedList a, String r, Exp b) {
      this (p,n,a,r,b,null);
   }
   public FunctionDec (int p, String n, LinkedList a, String r, Exp b, FunctionDec x) {
      super(p,n); params=a; result=r; body=b; next=x;
   }

   /*  Add another FunctionDec to end of this chain  */
   public void add (FunctionDec d) {
      if (next==null) {
	 next = d;
      } else {
	 next.add (d);
      }
   }

   
   public LinkedList add (LinkedList l) {
      if (l.size()!=0 && l.getLast() instanceof FunctionDec) {
	 // Add this FunctionDec to FunctionDec at end of list
	 ((FunctionDec) (l.getLast())) . add (this);
      } else {
	 // List does not end with a FunctionDec, so just add it to the list
	 l.addLast (this);
      }
      return l;
   }

      
}
