/*
 * CSE3001.  Compiler project based on "Modern Compiler Implementation
 * in Java" by Andrew W. Appel.
 *
 */

package syntax;

import java.util.LinkedList;

public class TypeDec extends Dec {
   public final TypeX type;
   public       TypeDec next;
   public TypeDec (int p, String n, TypeX t) {
      this (p,n,t,null);
   }
   public TypeDec (int p, String n, TypeX t, TypeDec x) {
      super(p,n); type=t; next=x;
   }

   /*  Add another TypeDec to end of this chain  */
   public void add (TypeDec d) {
      if (next==null) {
	 next = d;
      } else {
	 next.add (d);
      }
   }

   public LinkedList add (LinkedList l) {
      if (l.size()!=0 && l.getLast() instanceof TypeDec) {
	 // Add this TypeDec to TypeDec at end of list
	 ((TypeDec) (l.getLast())) . add (this);
      } else {
	 // List does not end with a TypeDec, so just add it to the list
	 l.addLast (this);
      }
      return l;
   }
}
